image: node:12-alpine

variables:
  POSTGRES_DB: $POSTGRES_DB
  POSTGRES_USER: $POSTGRES_USER
  POSTGRES_PASSWORD: $POSTGRES_PASSWORD

services:
  - postgres:latest

stages:
  # - lint
  # - tests
  - deploy

# lint:
#   stage: lint
#   before_script:
#     - yarn install
#   script:
#     - npm run lint

# tests:
#   stage: tests
#   before_script:
#     - yarn install
#   script:
#     - NODE_ENV=ci npm run test:ci
#   artifacts:
#     paths:
#       - coverage/

deploy_staging:
  stage: deploy
  image: jfloff/alpine-python
  only:
    - develop
  before_script:
    - apk update && apk add nodejs npm libressl-dev musl-dev libffi-dev
    - npm install -g yarn
    - yarn install
    - yarn build
    # - npm prune --production
    - pip install awscli --upgrade --user
    - pip install awsebcli --upgrade --user
    - export PATH=$PATH:$HOME/.local/bin
    - aws --profile advanced configure set aws_access_key_id "$AWS_ACCESS_KEY_ID"
    - aws --profile advanced configure set aws_secret_access_key "$AWS_SECRET_ACCESS_KEY"
    - aws --profile advanced configure set region us-east-1
    #- aws --region=us-east-1 ssm get-parameter --name "API_STAGING_ENV" --with-decryption --output text --query Parameter.Value > .env
  script:
    - eb use api-staging
    - eb deploy api-staging

deploy_prod:
  stage: deploy
  image: jfloff/alpine-python
  only:
    - master
  before_script:
    - apk update && apk add nodejs npm libressl-dev musl-dev libffi-dev
    - npm install -g yarn
    - yarn install
    - echo "MONGO_CONNECTION=$MONGO_URL_PROD" >> .env
    - echo "MFILES_VAULT=$MFILES_VAULT_PROD" >> .env
    - echo "ADVANCED_DYNAMICS_RESOURCE=$ADVANCED_DYNAMICS_RESOURCE_PROD" >> .env
    - echo "VUORI_API_BASE_URL=$VUORI_API_BASE_URL_PROD" >> .env
    - echo "FRONT_CREATE_URL_ENDPOINT=$FRONT_CREATE_URL_ENDPOINT_PROD" >> .env
    - yarn build
    # - npm prune --production
    - pip install awscli --upgrade --user
    - pip install awsebcli --upgrade --user
    - export PATH=$PATH:$HOME/.local/bin
    - aws --profile advanced configure set aws_access_key_id "$AWS_ACCESS_KEY_ID"
    - aws --profile advanced configure set aws_secret_access_key "$AWS_SECRET_ACCESS_KEY"
    - aws --profile advanced configure set region us-east-1
    #- aws --region=us-east-1 ssm get-parameter --name "API_PROD_ENV" --with-decryption --output text --query Parameter.Value > .env
  script:
    - eb use api-prod
    - eb deploy api-prod
